<?php
#
# Template for check_svc_csp
#
foreach ( $this->DS as $idx => $val ) {
    # Init variables for each loop iteration
    $color = "";
    $color_max = "";
    $lower_limit = "";
    $upper_limit = "";
    $name = "";
    $title = "";
    $uom = "";
    $pre = "";
    $critical = "";
    $warning = "";
    $vlabel = "";
    $sn = "";
    
    if ( preg_match('/^cap_/', $val['NAME']) ) {
        # Storage Pool Capacity
        #
        # Init variables for each loop iteration
        $color = "00FF00";
        $color_max = "FF0000";
        $lower_limit = "-l 0";
        $name = preg_replace('/^cap_/', '', $val['NAME']);
        $ds_name[$idx] = "Capacity ".$name;
        $title = "--title \"SVC Storage Pool Capacity - $hostname - $name\" ";
        $uom = "Bytes";
        $pre = "";
        $vlabel = '--vertical-label "Bytes"';
        $sn = $val['NAME'];
        #
        # RRDtool options
        $opt[$sn] = "$vlabel $lower_limit $upper_limit $title";
        #
        # Graph Definitions
        if ( !isset($def[$sn]) ) {
            $def[$sn] = "";
        }

        if ( $val['MAX'] > 1099511627776 ) {
            $pre = "T";
            $tmp_max = $val['MAX'] / 1099511627776;
        } elseif ( $val['MAX'] > 1073741824 ) {
            $pre = "G";
            $tmp_max = $val['MAX'] / 1073741824;
        } elseif ( $val['MAX'] > 1048576 ) {
            $pre = "M";
            $tmp_max = $val['MAX'] / 1048576;
        } elseif ( $val['MAX'] > 1024 ) {
            $pre = "K";
            $tmp_max = $val['MAX'] / 1024;
        }
        $def[$sn] .= "LINE2:".$val['MAX']."#".$color_max.":\"".sprintf("%-5s", "Total")." ".sprintf("%6.2lf", $tmp_max)." ".$pre.$uom."\\n\" "; 
        $def[$sn] .= "DEF:cap_".$name."=".$val['RRDFILE'].":".$val['DS'].":AVERAGE "; 
        $def[$sn] .= "AREA:cap_".$name."#".$color.":".sprintf("\"%-5s\"", "Used")." "; 
        $def[$sn] .= "DEF:cap_min_tmp_".$name."=".$val['RRDFILE'].":".$val['DS'].":MIN "; 
        $def[$sn] .= "DEF:cap_max_tmp_".$name."=".$val['RRDFILE'].":".$val['DS'].":MAX "; 
        if ( $val['MAX'] > 1099511627776 ) {
            $def[$sn] .= "CDEF:cap_avg_".$name."=cap_".$name.",1099511627776,/ ";
            $def[$sn] .= "CDEF:cap_min_".$name."=cap_min_tmp_".$name.",1099511627776,/ ";
            $def[$sn] .= "CDEF:cap_max_".$name."=cap_max_tmp_".$name.",1099511627776,/ ";
        } elseif ( $val['MAX'] > 1073741824 ) {
            $def[$sn] .= "CDEF:cap_avg_".$name."=cap_".$name.",1073741824,/ ";
            $def[$sn] .= "CDEF:cap_min_".$name."=cap_min_tmp_".$name.",1073741824,/ ";
            $def[$sn] .= "CDEF:cap_max_".$name."=cap_max_tmp_".$name.",1073741824,/ ";
        } elseif ( $val['MAX'] > 1048576 ) {
            $def[$sn] .= "CDEF:cap_avg_".$name."=cap_".$name.",1048576,/ ";
            $def[$sn] .= "CDEF:cap_min_".$name."=cap_min_tmp_".$name.",1048576,/ ";
            $def[$sn] .= "CDEF:cap_max_".$name."=cap_max_tmp_".$name.",1048576,/ ";
        } elseif ( $val['MAX'] > 1024 ) {
            $def[$sn] .= "CDEF:cap_avg_".$name."=cap_".$name.",1024,/ ";
            $def[$sn] .= "CDEF:cap_min_".$name."=cap_min_tmp_".$name.",1024,/ ";
            $def[$sn] .= "CDEF:cap_max_".$name."=cap_max_tmp_".$name.",1024,/ ";
        }
        $def[$sn] .= "GPRINT:cap_min_".$name.":MIN:\"Minimum\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:cap_avg_".$name.":AVERAGE:\"Average\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:cap_max_".$name.":MAX:\"Maximum\: %6.2lf ".$pre.$uom."\\n\" ";
    } elseif ( preg_match('/^md_/', $val['NAME']) ) {
        # Storage Pool Number of MDisks
        #
        # Init variables for each loop iteration
        $color = "00FF00";
        $lower_limit = "-l 0";
        $name = preg_replace('/^md_/', '', $val['NAME']);
        $ds_name[$idx] = "MDisks ".$name;
        $title = "--title \"SVC Storage Pool MDisks - $hostname - $name\" ";
        $uom = "";
        $pre = "";
        $vlabel = '--vertical-label "Count"';
        $sn = $val['NAME'];
        #
        # RRDtool options
        $opt[$sn] = "$vlabel $lower_limit $upper_limit $title";
        #
        # Graph Definitions
        if ( !isset($def[$sn]) ) {
            $def[$sn] = "";
        }

        $def[$sn] .= "DEF:md_".$name."=".$val['RRDFILE'].":".$val['DS'].":AVERAGE "; 
        $def[$sn] .= "AREA:md_".$name."#".$color.":".sprintf("\"%-6s\"", "MDisks")." "; 
        $def[$sn] .= "GPRINT:md_".$name.":MIN:\"Minimum\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:md_".$name.":AVERAGE:\"Average\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:md_".$name.":MAX:\"Maximum\: %6.2lf ".$pre.$uom."\\n\" ";
    } elseif ( preg_match('/^vd_/', $val['NAME']) ) {
        # Storage Pool Number of VDisks
        #
        # Init variables for each loop iteration
        $color = "00FF00";
        $lower_limit = "-l 0";
        $name = preg_replace('/^vd_/', '', $val['NAME']);
        $ds_name[$idx] = "VDisks ".$name;
        $title = "--title \"SVC Storage Pool VDisks - $hostname - $name\" ";
        $uom = "";
        $pre = "";
        $vlabel = '--vertical-label "Count"';
        $sn = $val['NAME'];
        #
        # RRDtool options
        $opt[$sn] = "$vlabel $lower_limit $upper_limit $title";
        #
        # Graph Definitions
        if ( !isset($def[$sn]) ) {
            $def[$sn] = "";
        }

        $def[$sn] .= "DEF:vd_".$name."=".$val['RRDFILE'].":".$val['DS'].":AVERAGE "; 
        $def[$sn] .= "AREA:vd_".$name."#".$color.":".sprintf("\"%-6s\"", "VDisks")." "; 
        $def[$sn] .= "GPRINT:vd_".$name.":MIN:\"Minimum\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:vd_".$name.":AVERAGE:\"Average\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:vd_".$name.":MAX:\"Maximum\: %6.2lf ".$pre.$uom."\\n\" ";
    }
}

# Uncomment to debug 
#
#$output = "<pre>".print_r($this->DS,TRUE)."</pre><BR><pre>".print_r($opt,TRUE)."</pre><BR><pre>".print_r($def,TRUE)."</pre>";
#throw new Kohana_exception($output);
?>
