<?php
#
# Template for check_svc_fcp_stats
#
foreach ( $this->DS as $idx => $val ) {
    # Init variables for each loop iteration
    $color = "";
    $color_max = "";
    $lower_limit = "";
    $upper_limit = "";
    $name = "";
    $title = "";
    $uom = "";
    $pre = "";
    $critical = "";
    $warning = "";
    $vlabel = "";
    $sn = "";
    
    if ( preg_match('/^bbzero_/', $val['NAME']) ) {
        # FC port buffer to buffer credit zero statistics value
        #
        # "Zero buffer-buffer credit timer in microseconds. This is reset after each collection
        # interval. This should be shown as a percentage of the interval time.
        #
        # Init variables for each loop iteration
        $color = "00FF00";
        $lower_limit = "-l 0";
        preg_match('/(\S+)_n(\d+)p(\d+)/', $val['NAME'], $node_port);
        $stat = $node_port[1];
        $node = $node_port[2];
        $port = $node_port[3];
        $title = "--title \"SVC FC Port BBCreditZero - $hostname - Node $node Port $port\" ";
        $uom = "µs";
        $pre = "";
        $vlabel = '--vertical-label "Microseconds"';
        $sn = 'bbzero_n'.$node.'p'.$port;
        #
        # RRDtool options
        $ds_name[$sn] = "FC Port BBCreditZero Node ".$node." Port ".$port;
        $opt[$sn] = "$vlabel $lower_limit $upper_limit $title";
        #
        # Graph Definitions
        if ( !isset($def[$sn]) ) {
            $def[$sn] = "";
        }

        $def[$sn] .= "DEF:".$stat."=".$val['RRDFILE'].":".$val['DS'].":AVERAGE "; 
        $def[$sn] .= "LINE1:".$stat."#".$color.":".sprintf("\"%-8s\"", "BBCreditZero")." "; 
        $def[$sn] .= "GPRINT:".$stat.":MIN:\"Minimum\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:".$stat.":AVERAGE:\"Average\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:".$stat.":MAX:\"Maximum\: %6.2lf ".$pre.$uom."\\n\" ";
    } elseif ( preg_match('/^(crc|inval|lf|losig|losync|pspec)_/', $val['NAME']) ) {
        # Several FC port error statistics values
        #
        # Init variables for each loop iteration
        $color = "00FF00";
        $lower_limit = "-l 0";
        preg_match('/(\S+)_n(\d+)p(\d+)/', $val['NAME'], $node_port);
        $stat = $node_port[1];
        $node = $node_port[2];
        $port = $node_port[3];
        $title = "--title \"SVC FC Port Errors - $hostname - Node $node Port $port\" ";
        $uom = "";
        $pre = "";
        $vlabel = '--vertical-label "Count"';
        $sn = 'error_n'.$node.'p'.$port;
        #
        # RRDtool options
        $ds_name[$sn] = "FC Port Errors Node ".$node." Port ".$port;
        $opt[$sn] = "$vlabel $lower_limit $upper_limit $title";
        #
        # Graph Definitions
        if ( !isset($def[$sn]) ) {
            $def[$sn] = "";
        }

        if ( $stat == 'crc' ) {
            $color = "00FF00";
            $stat_name = 'CRC Error';
        } elseif ( $stat == 'inval' ) {
            $color = "FF0000";
            $stat_name = 'Invalid Words';
        } elseif ( $stat == 'lf' ) {
            $color = "0000FF";
            $stat_name = 'Link Failure';
        } elseif ( $stat == 'losig' ) {
            $color = "FF00FF";
            $stat_name = 'Signal Loss';
        } elseif ( $stat == 'losync' ) {
            $color = "FFFF00";
            $stat_name = 'Sync Loss';
        } elseif ( $stat == 'pspec' ) {
            $color = "000000";
            $stat_name = 'PSP Error';
        }
        $def[$sn] .= "DEF:".$stat."=".$val['RRDFILE'].":".$val['DS'].":AVERAGE "; 
        $def[$sn] .= "LINE1:".$stat."#".$color.":".sprintf("\"%-13s\"", $stat_name)." "; 
        $def[$sn] .= "GPRINT:".$stat.":MIN:\"Minimum\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:".$stat.":AVERAGE:\"Average\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:".$stat.":MAX:\"Maximum\: %6.2lf ".$pre.$uom."\\n\" ";
    } elseif ( preg_match('/^(recv|trans)_/', $val['NAME']) ) {
        # FC port traffic statistics values
        #
        # Init variables for each loop iteration
        $color = "00FF00";
        $lower_limit = "-l 0";
        preg_match('/(\S+)_n(\d+)p(\d+)/', $val['NAME'], $node_port);
        $stat = $node_port[1];
        $node = $node_port[2];
        $port = $node_port[3];
        $title = "--title \"SVC FC Port Traffic - $hostname - Node $node Port $port\" ";
        $uom = "Bytes";
        $pre = "M";
        $vlabel = '--vertical-label "Bytes"';
        $sn = 'traffic_n'.$node.'p'.$port;
        #
        # RRDtool options
        $ds_name[$sn] = "FC Port Traffic Node ".$node." Port ".$port;
        $opt[$sn] = "$vlabel $lower_limit $upper_limit $title";
        #
        # Graph Definitions
        if ( !isset($def[$sn]) ) {
            $def[$sn] = "";
        }

        if ( $stat == 'recv' ) {
            $color = "00FF00";
            $stat_name = 'Receive';
        } elseif ( $stat == 'trans' ) {
            $color = "0000FF";
            $stat_name = 'Transmit';
        }
        $def[$sn] .= "DEF:".$stat."=".$val['RRDFILE'].":".$val['DS'].":AVERAGE "; 
        $def[$sn] .= "CDEF:tmp_".$stat."=".$stat.",1048576,/ ";
        $def[$sn] .= "LINE1:".$stat."#".$color.":".sprintf("\"%-8s\"", $stat_name)." "; 
        $def[$sn] .= "GPRINT:tmp_".$stat.":MIN:\"Minimum\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:tmp_".$stat.":AVERAGE:\"Average\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:tmp_".$stat.":MAX:\"Maximum\: %6.2lf ".$pre.$uom."\\n\" ";
    }
}

# Uncomment to debug 
#
#$output = "<pre>".print_r($this->DS,TRUE)."</pre><BR><pre>".print_r($opt,TRUE)."</pre><BR><pre>".print_r($def,TRUE)."</pre>";
#throw new Kohana_exception($output);
?>
