<?php
#
# Template for check_svc_iogrp
#
foreach ( $this->DS as $idx => $val ) {
    # Init variables for each loop iteration
    $color = "";
    $color_max = "";
    $lower_limit = "";
    $upper_limit = "";
    $name = "";
    $title = "";
    $uom = "";
    $pre = "";
    $critical = "";
    $warning = "";
    $vlabel = "";
    $sn = "";
    
    if ( preg_match('/^mem_/', $val['NAME']) ) {
        #
        # Init variables for each loop iteration
        $color_free = "00FF00";
        $color_used = "FF0000";
        $color_max  = "000000";
        $lower_limit = "-l 0";
        $name = "";
        $ds_name[$idx] = "";
        $title = "";
        $uom = "Bytes";
        $pre = "";
        $vlabel = '--vertical-label "Bytes"';
        $sn = $val['NAME'];
        if ( preg_match('/^mem_fc_/', $val['NAME']) ) {
            # Memory for FlashCopy in I/O Group
            $ds_name[$idx] = "FlashCopy Memory ".$name;
            $name = preg_replace('/^mem_fc_/', '', $val['NAME']);
            $title = "--title \"SVC I/O Group FlashCopy Memory - $hostname - $name\" ";
        } elseif ( preg_match('/^mem_mirr_/', $val['NAME']) ) {
            # Memory for Metadata Mirror in I/O Group
            $ds_name[$idx] = "Metadata Mirror Memory ".$name;
            $name = preg_replace('/^mem_mirr_/', '', $val['NAME']);
            $title = "--title \"SVC I/O Group Metadata Mirror Memory - $hostname - $name\" ";
        } elseif ( preg_match('/^mem_raid_/', $val['NAME']) ) {
            # Memory for RAID Bitmaps in I/O Group
            $ds_name[$idx] = "RAID Bitmap Memory ".$name;
            $name = preg_replace('/^mem_riad_/', '', $val['NAME']);
            $title = "--title \"SVC I/O Group RAID Bitmap Memory - $hostname - $name\" ";
        } elseif ( preg_match('/^mem_rc_/', $val['NAME']) ) {
            # Memory for RemoteCopy in I/O Group
            $ds_name[$idx] = "RemoteCopy Memory ".$name;
            $name = preg_replace('/^mem_rc_/', '', $val['NAME']);
            $title = "--title \"SVC I/O Group RemoteCopy Memory - $hostname - $name\" ";
        }
        #
        # RRDtool options
        $opt[$sn] = "$vlabel $lower_limit $upper_limit $title";
        #
        # Graph Definitions
        if ( !isset($def[$sn]) ) {
            $def[$sn] = "";
        }

        $def[$sn] .= "DEF:free=".$val['RRDFILE'].":".$val['DS'].":AVERAGE "; 
        $def[$sn] .= "CDEF:used=".$val['MAX'].",free,- ";
        if ( $val['MAX'] > 1099511627776 ) {
            $pre = "T";
            $def[$sn] .= "CDEF:tmp_used=used,1099511627776,/ ";
        } elseif ( $val['MAX'] > 1073741824 ) {
            $pre = "G";
            $def[$sn] .= "CDEF:tmp_used=used,1073741824,/ ";
        } elseif ( $val['MAX'] > 1048576 ) {
            $pre = "M";
            $def[$sn] .= "CDEF:tmp_used=used,1048576,/ ";
        } elseif ( $val['MAX'] > 1024 ) {
            $pre = "K";
            $def[$sn] .= "CDEF:tmp_used=used,1024,/ ";
        } else {
            $pre = "";
            $def[$sn] .= "CDEF:tmp_used=used,1,/ ";
        }
        $def[$sn] .= "AREA:used#".$color_used.":\"Used\" ";
        $def[$sn] .= "GPRINT:tmp_used:MIN:\"%6.2lf ".$pre.$uom."\\n\" ";
        $def[$sn] .= "STACK:free#".$color_free.":".sprintf("\"%-5s\"", "Free")." "; 
        $def[$sn] .= "DEF:free_min_tmp=".$val['RRDFILE'].":".$val['DS'].":MIN "; 
        $def[$sn] .= "DEF:free_max_tmp=".$val['RRDFILE'].":".$val['DS'].":MAX "; 
        if ( $val['MAX'] > 1099511627776 ) {
            $def[$sn] .= "CDEF:free_avg=free,1099511627776,/ ";
            $def[$sn] .= "CDEF:free_min=free_min_tmp,1099511627776,/ ";
            $def[$sn] .= "CDEF:free_max=free_max_tmp,1099511627776,/ ";
            $tmp_max = $val['MAX'] / 1099511627776;
        } elseif ( $val['MAX'] > 1073741824 ) {
            $def[$sn] .= "CDEF:free_avg=free,1073741824,/ ";
            $def[$sn] .= "CDEF:free_min=free_min_tmp,1073741824,/ ";
            $def[$sn] .= "CDEF:free_max=free_max_tmp,1073741824,/ ";
            $tmp_max = $val['MAX'] / 1073741824;
        } elseif ( $val['MAX'] > 1048576 ) {
            $def[$sn] .= "CDEF:free_avg=free,1048576,/ ";
            $def[$sn] .= "CDEF:free_min=free_min_tmp,1048576,/ ";
            $def[$sn] .= "CDEF:free_max=free_max_tmp,1048576,/ ";
            $tmp_max = $val['MAX'] / 1048576;
        } elseif ( $val['MAX'] > 1024 ) {
            $def[$sn] .= "CDEF:free_avg=free,1024,/ ";
            $def[$sn] .= "CDEF:free_min=free_min_tmp,1024,/ ";
            $def[$sn] .= "CDEF:free_max=free_max_tmp,1024,/ ";
            $tmp_max = $val['MAX'] / 1024;
        } else {
            $def[$sn] .= "CDEF:free_avg=free,1,/ ";
            $def[$sn] .= "CDEF:free_min=free_min_tmp,1,/ ";
            $def[$sn] .= "CDEF:free_max=free_max_tmp,1,/ ";
            $tmp_max = $val['MAX'] / 1;
        }
        $def[$sn] .= "GPRINT:free_min:MIN:\"Minimum\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:free_avg:AVERAGE:\"Average\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:free_max:MAX:\"Maximum\: %6.2lf ".$pre.$uom."\\n\" ";
        $def[$sn] .= "LINE1:".$val['MAX']."#".$color_max.":\"".sprintf("%-5s", "Total")." ".sprintf("%6.2lf", $tmp_max)." ".$pre.$uom."\\n\" "; 
    } elseif ( preg_match('/^num_hosts_/', $val['NAME']) ) {
        # Number of hosts in I/O Group
        #
        # Init variables for each loop iteration
        $color = "00FF00";
        $lower_limit = "-l 0";
        $name = preg_replace('/^num_hosts_/', '', $val['NAME']);
        $ds_name[$idx] = "Hosts ".$name;
        $title = "--title \"SVC I/O Group Hosts - $hostname - $name\" ";
        $uom = "";
        $pre = "";
        $vlabel = '--vertical-label "Count"';
        $sn = $val['NAME'];
        #
        # RRDtool options
        $opt[$sn] = "$vlabel $lower_limit $upper_limit $title";
        #
        # Graph Definitions
        if ( !isset($def[$sn]) ) {
            $def[$sn] = "";
        }

        $def[$sn] .= "DEF:num_hosts_".$name."=".$val['RRDFILE'].":".$val['DS'].":AVERAGE "; 
        $def[$sn] .= "AREA:num_hosts_".$name."#".$color.":".sprintf("\"%-6s\"", "Hosts")." "; 
        $def[$sn] .= "GPRINT:num_hosts_".$name.":MIN:\"Minimum\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:num_hosts_".$name.":AVERAGE:\"Average\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:num_hosts_".$name.":MAX:\"Maximum\: %6.2lf ".$pre.$uom."\\n\" ";
    } elseif ( preg_match('/^num_nodes_/', $val['NAME']) ) {
        # Number of nodes in I/O Group
        #
        # Init variables for each loop iteration
        $color = "00FF00";
        $lower_limit = "-l 0";
        $name = preg_replace('/^num_nodes_/', '', $val['NAME']);
        $ds_name[$idx] = "Nodes ".$name;
        $title = "--title \"SVC I/O Group Nodes - $hostname - $name\" ";
        $uom = "";
        $pre = "";
        $vlabel = '--vertical-label "Count"';
        $sn = $val['NAME'];
        #
        # RRDtool options
        $opt[$sn] = "$vlabel $lower_limit $upper_limit $title";
        #
        # Graph Definitions
        if ( !isset($def[$sn]) ) {
            $def[$sn] = "";
        }

        $def[$sn] .= "DEF:num_nodes_".$name."=".$val['RRDFILE'].":".$val['DS'].":AVERAGE "; 
        $def[$sn] .= "AREA:num_nodes_".$name."#".$color.":".sprintf("\"%-6s\"", "Nodes")." "; 
        $def[$sn] .= "GPRINT:num_nodes_".$name.":MIN:\"Minimum\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:num_nodes_".$name.":AVERAGE:\"Average\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:num_nodes_".$name.":MAX:\"Maximum\: %6.2lf ".$pre.$uom."\\n\" ";
    } elseif ( preg_match('/^num_vol_/', $val['NAME']) ) {
        # Number of volumes in I/O Group
        #
        # Init variables for each loop iteration
        $color = "00FF00";
        $lower_limit = "-l 0";
        $name = preg_replace('/^num_vol_/', '', $val['NAME']);
        $ds_name[$idx] = "Volumes ".$name;
        $title = "--title \"SVC I/O Group Volumes - $hostname - $name\" ";
        $uom = "";
        $pre = "";
        $vlabel = '--vertical-label "Count"';
        $sn = $val['NAME'];
        #
        # RRDtool options
        $opt[$sn] = "$vlabel $lower_limit $upper_limit $title";
        #
        # Graph Definitions
        if ( !isset($def[$sn]) ) {
            $def[$sn] = "";
        }

        $def[$sn] .= "DEF:num_vol_".$name."=".$val['RRDFILE'].":".$val['DS'].":AVERAGE "; 
        $def[$sn] .= "AREA:num_vol_".$name."#".$color.":".sprintf("\"%-6s\"", "Volumes")." "; 
        $def[$sn] .= "GPRINT:num_vol_".$name.":MIN:\"Minimum\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:num_vol_".$name.":AVERAGE:\"Average\: %6.2lf ".$pre.$uom."\" ";
        $def[$sn] .= "GPRINT:num_vol_".$name.":MAX:\"Maximum\: %6.2lf ".$pre.$uom."\\n\" ";
    }
}

# Uncomment to debug 
#
#$output = "<pre>".print_r($this->DS,TRUE)."</pre><BR><pre>".print_r($opt,TRUE)."</pre><BR><pre>".print_r($def,TRUE)."</pre>";
#throw new Kohana_exception($output);
?>
